'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _postcss = require('postcss');

var _postcss2 = _interopRequireDefault(_postcss);

var _process = require('./process');

var _process2 = _interopRequireDefault(_process);

var _reset = require('./reset');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isPositionDecl = function isPositionDecl(node) {
  return node.type === 'decl' && ['horizontal', 'vertical', 'type'].some(function (prop) {
    return prop === node.prop;
  });
};

var hasPositionDecl = function hasPositionDecl(rule) {
  return rule.nodes.some(isPositionDecl);
};

var defaults = {
  reset: 'minimal',
  warn: 'same',
  dev: false
};

module.exports = _postcss2.default.plugin('postcss-positioning', function (opts) {
  opts = _extends({}, defaults, opts);

  return function (root) {
    root.walkRules(function (rule) {
      if (hasPositionDecl(rule)) {
        (0, _process2.default)(rule);
      }
    });

    switch (opts.reset) {
      case 'full':
        root.prepend(_reset.full);
        break;
      case 'minimal':
        root.prepend(_reset.minimal);
        break;
    }
  };
});