'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); // The position data type that stores position info

var _enum = require('../enum');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Position = function () {
  function Position(_ref) {
    var horizontal = _ref.horizontal,
        vertical = _ref.vertical,
        align = _ref.align,
        type = _ref.type,
        margins = _ref.margins;

    _classCallCheck(this, Position);

    this.horizontal = horizontal;
    this.vertical = vertical;
    if (align) this.align = align;
    if (type) this.type = type;
    if (margins) this.margins = margins;
  }

  _createClass(Position, [{
    key: 'iterableDirections',
    value: function iterableDirections() {
      return [{
        dir: _enum.direction.horizontal,
        lengths: this.horizontal
      }, {
        dir: _enum.direction.vertical,
        lengths: this.vertical
      }];
    }
  }, {
    key: 'iterateDirections',
    value: function iterateDirections(callback) {
      this.iterableDirections().forEach(function (_ref2) {
        var dir = _ref2.dir,
            lengths = _ref2.lengths;

        callback(dir, function (target) {
          return Object.keys(target).map(function (key) {
            return target[key];
          });
        }(lengths));
      });
    }
  }, {
    key: 'iterateLengths',
    value: function iterateLengths(callback) {
      this.iterableDirections().forEach(function (_ref3) {
        var dir = _ref3.dir,
            lengths = _ref3.lengths;

        (function (target) {
          return Object.keys(target).map(function (key) {
            return [key, target[key]];
          });
        })(lengths).forEach(function (_ref4) {
          var _ref5 = _slicedToArray(_ref4, 2),
              key = _ref5[0],
              value = _ref5[1];

          callback(dir, key, value);
        });
      });
    }

    // Set lengths for a direction, ignoring undefined

  }, {
    key: 'setDirection',
    value: function setDirection(dir, lengths) {
      this[dir.prop] = _extends({}, lengths[0] && { before: lengths[0] }, lengths[1] && { size: lengths[1] }, lengths[2] && { after: lengths[2] });
    }
  }, {
    key: 'isAlignedInDirection',
    value: function isAlignedInDirection(dir) {
      return this.align && this.align === dir;
    }
  }]);

  return Position;
}();

exports.default = Position;