'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.stretchUndef = exports.isCalc = undefined;

exports.default = function () {
  var _this = this;

  this.iterateDirections(function (direction, lengths) {
    if (lengths.length !== 3) {
      return;
    }
    lengths = stretchUndef(lengths, 1);
    _this.setDirection(direction, lengths);
  });
  return this;
};

var _stretch = require('./stretch');

// Tells if a string is a calc expressiong
var isCalc = exports.isCalc = function isCalc(length) {
  return length.slice(0, 5) === 'calc(' && length.slice(-1) === ')';
};

// Turns the last n stretch lengths (processed or not) into undefined
var stretchUndef = exports.stretchUndef = function stretchUndef(lengths, n) {
  return lengths.reverse().map(function (length) {
    if ((isCalc(length) || (0, _stretch.isStretch)(length)) && n !== 0) {
      n--;
      return undefined;
    } else {
      return length;
    }
  }).reverse();
};

// Remove redundant lengths after processing stretch units