'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (rule) {
  var _this = this;

  if (this.align && this.type) {
    throw rule.error('Cannot align and be ' + this.type);
  }

  this.iterateDirections(function (direction, lengths) {
    var hasStretch = lengths.some(function (element) {
      return (0, _stretch.isStretch)(element);
    });
    var isAlign = _this.isAlignedInDirection(direction);

    if (hasStretch && isAlign) {
      throw rule.error('Cannot use stretch values and align on the same axis');
    }

    if (!hasStretch && !isAlign) {
      throw rule.error('Must have at least one stretch value ' + 'when not specifying align');
    }
  });

  return this;
};

var _stretch = require('./stretch');