'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resetDeclaration = exports.transformValue = undefined;

var _stretch = require('./position/stretch');

var transformValue = exports.transformValue = function transformValue(direction, ratio) {
  return direction.transform + '(' + (0, _stretch.wrapCalc)('-' + ratio) + ')';
}; // Successively combines transforms into a single declaration

var declaration = void 0;

var resetDeclaration = exports.resetDeclaration = function resetDeclaration() {
  declaration = undefined;
};

exports.default = function (rule, direction, ratio) {
  var value = transformValue(direction, ratio);

  if (declaration) {
    declaration.value += ' ' + value;
  } else {
    declaration = rule.append({
      prop: 'transform',
      value
    }).last;
    rule.append({
      prop: 'display',
      value: 'inline-block'
    });
  }
};